# -*- coding: utf-8 -*-
import sys,logging,unicodedata,urllib2,urllib,zlib,json,os,xbmcvfs,zipfile,re,xbmcgui,xbmcaddon,contextlib
from os import path
from requests import get
from json import loads, load
from shutil import copyfileobj, rmtree
from time import time
from unicodedata import normalize
from urllib import urlretrieve, unquote_plus, unquote, urlopen, quote
from xbmcaddon import Addon
from xbmcplugin import endOfDirectory, addDirectoryItem
from xbmcgui import ListItem, Dialog

from xbmcvfs import listdir, exists, mkdirs
from xbmc import translatePath, executebuiltin, getInfoLabel, executeJSONRPC, Player, sleep, log, getCondVisibility
from re import sub
from  Subscene import search_subscene,download_subscene
from opensubtitle import Search_opensubtitle,Download_opensubtitle
try:
    import StorageServer
except ImportError:
    import storageserverdummy as StorageServer
regexHelper = re.compile('\W+', re.UNICODE)

MyAddon = Addon()
MyScriptID = MyAddon.getAddonInfo('id')
MyVersion = MyAddon.getAddonInfo('version')
__scriptid__ = MyAddon.getAddonInfo('id')
__scriptname__ = MyAddon.getAddonInfo('name')
MyTmp = translatePath(MyAddon.getAddonInfo('profile')).encode('utf-8')
MySubFolder = translatePath(path.join(MyTmp, 'subs')).encode('utf-8')
MyName = MyAddon.getAddonInfo('name')
MyLang = MyAddon.getLocalizedString
__settings__ = xbmcaddon.Addon(id=MyScriptID)
store = StorageServer.StorageServer(__scriptname__, int(24 * 364 / 2))  # 6 months
__profile__ = unicode(xbmc.translatePath(MyAddon.getAddonInfo('profile')), 'utf-8')
__language__ = MyAddon.getLocalizedString
__temp__ = unicode(xbmc.translatePath(os.path.join(__profile__, 'temp')), 'utf-8')
BASE_URL = "http://www.cinemast.org/he/cinemast/api/"
id_all_collection=[]
class URLHandler():
    def __init__(self):
        self.opener = urllib2.build_opener()
        self.opener.addheaders = [('Accept-Encoding', 'gzip'),
                                  ('Accept-Language', 'en-us,en;q=0.5'),
                                  ('Pragma', 'no-cache'),
                                  ('Cache-Control', 'no-cache'),
                                  ('User-Agent',
                                   'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 Kodi/17.2 (KHTML, like Gecko) Chrome/49.0.2526.111 Safari/537.36')]

    def request(self, url, data=None, query_string=None, ajax=False, referrer=None, cookie=None):
        if data is not None:
            data = urllib.urlencode(data)
        if query_string is not None:
            url += '?' + urllib.urlencode(query_string)
        if ajax:
            self.opener.addheaders += [('X-Requested-With', 'XMLHttpRequest')]
        if referrer is not None:
            self.opener.addheaders += [('Referrer', referrer)]
        if cookie is not None:
            self.opener.addheaders += [('Cookie', cookie)]

        content = None
        log("Getting url: %s" % (url))
        if data is not None and 'password' not in data:
            log("Post Data: %s" % (data))
        try:
            response = self.opener.open(url, data)
            content = None if response.code != 200 else response.read()

            if response.headers.get('content-encoding', '') == 'gzip':
                try:
                    content = zlib.decompress(content, 16 + zlib.MAX_WBITS)
                except zlib.error:
                    pass

            if response.headers.get('content-type', '') == 'application/json':
                content = json.loads(content, encoding="utf-8")

            response.close()
        except Exception as e:
            log("Failed to get url: %s\n%s" % (url, e))
            # Second parameter is the filename
        return content
urlHandler = URLHandler()
def notify(msg_id):
    xbmc.executebuiltin((u'Notification(%s,%s)' % (__scriptname__, __language__(msg_id))).encode('utf-8'))
def login( notify_success=True):
        
  
        email = MyAddon.getSetting("Email")
        password = MyAddon.getSetting("Password")
        if email=='' or password=='':
          __settings__.openSettings()
          email = MyAddon.getSetting("Email")
          password = MyAddon.getSetting("Password")
        post_data = {'username': email, 'password': password}
        content = urlHandler.request(BASE_URL + "login/", post_data)

        if content['result'] == 'success':
            if notify_success:
                notify(32010)

            del content["result"]
            return content
        else:
            notify(32009)
            return None
		
def get_user_token( force_update=False):
        if force_update:
            store.delete('credentials')

        results = store.get('credentials')
        if results:
            results = json.loads(results)
        else:
            results = login(False)
            if results:
                store.set('credentials', json.dumps(results))
        
        return results
		
def convert_to_utf(file):
	try:
		with codecs.open(file, "r", "cp1255") as f:
			srt_data = f.read()

		with codecs.open(file, 'w', 'utf-8') as output:
			output.write(srt_data)
	except: pass

def lowercase_with_underscores(str):
    
    return normalize('NFKD', unicode(str)).encode('utf-8', 'ignore')

def take_title_from_focused_item():
    labelType = xbmc.getInfoLabel("ListItem.DBTYPE")  # movie/tvshow/season/episode
    labelMovieTitle = xbmc.getInfoLabel("ListItem.OriginalTitle")
    labelYear = xbmc.getInfoLabel("ListItem.Year")
    labelTVShowTitle = xbmc.getInfoLabel("ListItem.TVShowTitle")
    labelSeason = xbmc.getInfoLabel("ListItem.Season")
    labelEpisode = xbmc.getInfoLabel("ListItem.Episode")
    isItMovie = xbmc.getCondVisibility("Container.Content(movies)") or labelType == 'movie'
    isItEpisode = xbmc.getCondVisibility("Container.Content(episodes)") or labelType == 'episode'

    title = 'SearchFor...'
    if isItMovie and labelMovieTitle and labelYear:
        title = labelMovieTitle + " " + labelYear
    elif isItEpisode and labelTVShowTitle and labelSeason and labelEpisode:
        title = ("%s S%.2dE%.2d" % (labelTVShowTitle, int(labelSeason), int(labelEpisode)))

    return title

def download(id,language,key,filename):
	
	if filename!='':
	
		subtitle_list = []
		exts = [".srt", ".sub"]
   
		zip_filename = os.path.join(__temp__, "subs.zip")


		if xbmcvfs.exists(__temp__):
			shutil.rmtree(__temp__)
		xbmcvfs.mkdirs(__temp__)

		query = {"v": filename,"key": key,"sub_id": id}

		user_token = get_user_token()

		url = BASE_URL + "subtitle/download/" + language + "/?" + urllib.urlencode(query)
		
		f = urlHandler.request(url, user_token)
        #logging.warning(f)
		if len(f)<100:
			xbmcgui.Dialog().ok("Subscenter",str(f))
		else:
			with open(zip_filename, "wb") as subFile:
				subFile.write(f)
			subFile.close()
			xbmc.sleep(500)
          #logging.warning(zip_filename)
			with contextlib.closing(zipfile.ZipFile(zip_filename , "r")) as z:
				z.extractall(__temp__)
			#with zipfile.ZipFile(zip_filename) as zf:
			#	zf.extractall(__temp__)
		file_list=(os.listdir(__temp__ ))
     
		for file in file_list:
			full_path = os.path.join(__temp__, file)
			#logging.warning(__temp__)
			if os.path.splitext(full_path)[1] in exts:
			  subtitle_list.append(full_path)

		return subtitle_list
	else:
		
		try:
			rmtree(MySubFolder)
		except: pass
		mkdirs(MySubFolder)
		subtitle_list = []
		exts = [".srt", ".sub", ".str"]
		archive_file = path.join(MyTmp, 'wizdom.sub.'+id+'.zip')
		if not path.exists(archive_file):
			urlretrieve("http://zip.wizdom.xyz/"+id+".zip", archive_file)
		executebuiltin(('XBMC.Extract("%s","%s")' % (archive_file, MySubFolder)).encode('utf-8'), True)
		for file_ in listdir(MySubFolder)[1]:
			ufile = file_.decode('utf-8')
			file_ = path.join(MySubFolder, ufile)
			if path.splitext(ufile)[1] in exts:
				convert_to_utf(file_)
				subtitle_list.append(file_)
		return subtitle_list

def getParams(arg):
	param=[]
	paramstring=arg
	if len(paramstring)>=2:
		params=arg
		cleanedparams=params.replace('?','')
		if (params[len(params)-1]=='/'):
			params=params[0:len(params)-2]
		pairsofparams=cleanedparams.split('&')
		param={}
		for i in range(len(pairsofparams)):
			splitparams={}
			splitparams=pairsofparams[i].split('=')
			if (len(splitparams))==2:	
				param[splitparams[0]]=splitparams[1]
							
	return param

def getParam(name,params):
	try:
		return unquote_plus(params[name])
	except:	pass

def GetJson(imdb,season=0,episode=0,version=0):
	filename = 'wizdom.imdb.%s.%s.%s.json'%(imdb,season,episode)
	url = "http://api.wizdom.xyz/search.id.php?imdb=%s&season=%s&episode=%s&version=%s"%(imdb,season,episode,version)

	MyLog("GetJson:%s"%url)
	json_object = Caching(filename,url)
	subs_rate = []
	if json_object<>0:
		for item_data in json_object:
			listitem = ListItem(label= "Hebrew",label2= '[Wiz]'+item_data["versioname"],thumbnailImage="he",iconImage="%s"%(item_data["score"]/2))
			if int(item_data["score"])>8:
				listitem.setProperty("sync", "true")
			url = "plugin://%s/?action=download&versioname=%s&id=%s" % (MyScriptID, item_data["versioname"], item_data["id"])
			if item_data["id"] not in id_all_collection:
				id_all_collection.append(item_data["id"])
				
				addDirectoryItem(handle=int(sys.argv[1]),url=url,listitem=listitem,isFolder=False)

def SearchMovie(query,year):
	
	tmdbKey = '653bb8af90162bd98fc7ee32bcbbfb3d'
	filename = 'wizdom.search.movie.%s.%s.json'%(lowercase_with_underscores(query),year)
	if year>0:
		url = "http://api.tmdb.org/3/search/movie?api_key=%s&query=%s&year=%s&language=he"%(tmdbKey,quote(query),year)
	else:
		url = "http://api.tmdb.org/3/search/movie?api_key=%s&query=%s&language=he"%(tmdbKey,quote(query))
	json = Caching(filename,url)
	try:	tmdb_id = int(json["results"][0]["id"])
	except:	return 0

	filename = 'wizdom.tmdb.%s.json'%(tmdb_id)
	url = "http://api.tmdb.org/3/movie/%s?api_key=%s&language=en"%(tmdb_id,tmdbKey)
	json = Caching(filename,url)
	try:	imdb_id = json["imdb_id"]
	except:	return 0

	return imdb_id

def Caching(filename,url):
	json_file = path.join(MyTmp, filename)
	if not path.exists(json_file) or not path.getsize(json_file)>20 or (time()-path.getmtime(json_file)>30*60):
		urlretrieve(url, json_file)
	if path.exists(json_file) and path.getsize(json_file)>20:
		with open(json_file) as json_data:
			json_object = load(json_data)
		return json_object
	else:
		return 0

def ManualSearch(title):
	filename = 'wizdom.search.filename.%s.json'%(quote(title))
	url = "http://api.wizdom.xyz/search.manual.php?filename=%s"%(lowercase_with_underscores(title))
	try:
		json = Caching(filename,url)
		if json["type"]=="episode":
			imdb_id = urlopen("http://api.wizdom.xyz/search.tv.php?name="+quote(json['title'])).read()
			if imdb_id<>'' and imdb_id<>0:
				GetJson(str(imdb_id),json['season'],json['episode'],lowercase_with_underscores(title))
		elif json["type"]=="movie":
			if "year" in json:
				imdb_id = SearchMovie(str(json['title']),json['year'])
			else:
				imdb_id = SearchMovie(str(json['title']),0)
			if imdb_id:
				GetJson(str(imdb_id),0,0,lowercase_with_underscores(title))
	except:	pass
#///////////////////////////////////////Subcenter////////////////////////////////////////////////
def subcenter_search( item):
        results = []
        
        id_collection=[]
        search_string = re.split(r'\s\(\w+\)$', item["tvshow"])[0] if item["tvshow"] else item["title"]
        user_token =  get_user_token()
        
        if user_token:
            query = {"q": search_string.encode("utf-8"), "user": user_token["user"], "token": user_token["token"]}
            if item["tvshow"]:
                query["type"] = "series"
                query["season"] = item["season"]
                query["episode"] = item["episode"]
            else:
                query["type"] = "movies"
                if item["year"]:
                    query["year_start"] = int(item["year"]) 
                    query["year_end"] = int(item["year"])

            search_result =  urlHandler.request( BASE_URL + "search/", query)
   
            if search_result is not None and search_result["result"] == "failed":
                # Update cached token
                user_token =  get_user_token(True)
                query["token"] = user_token["token"]
                search_result =  urlHandler.request( BASE_URL + "search/", query)

            if search_result is not None and search_result["result"] == "failed":
                notify(32009)
                return results

            log("Results: %s" % search_result)

            if search_result is None or search_result["result"] != "success" or search_result["count"] < 1:
                return results  # return empty set

            results = search_result# _filter_results(search_result["data"], search_string, item)
            ##logging.warning('First Results:')
            ##logging.warning(results)
            log("Filtered: %s" % results)

        else:
            notify(32009)
        ret = []

  
        for result in results['data']:
            total_downloads = 0
            counter = 0
            
            subs_list = result
     
            if subs_list is not None:
               
                ##logging.warning(subs_list)
                for language in subs_list['subtitles']:
                        
                        
                       if language=='he':
                    #if xbmc.convertLanguage(language, xbmc.ISO_639_2) in item["3let_language"]:
                        for current in subs_list['subtitles'][language]:
                            
                            ##logging.warning(current)
                            counter += 1
                            title = current["version"]
                            subtitle_rate = 0
                            total_downloads += int(current["downloads"])
                            ret.append(
                                {   'lang_index':'0',# item["3let_language"].index('heb'),
                                    'filename': title,
                                    'link': current["key"],
                                    'language_name': xbmc.convertLanguage(language, xbmc.ENGLISH_NAME),
                                    'language_flag': language,
                                    'id': current["id"],
                                    'rating': current["downloads"],
                                    'sync': subtitle_rate >= 3.8,
                                    'hearing_imp': False,
                                    'is_preferred':
                                        xbmc.convertLanguage(language, xbmc.ISO_639_2) == item[
                                            'preferredlanguage']
                                })
            # Fix the rating
            if total_downloads:
                for it in ret[-1 * counter:]:
                    it["rating"] = str(min(int(round(float(it["rating"]) / float(total_downloads), 1) * 8), 5))
        ##logging.warning('ret:')
        ##logging.warning(ret)
        number_of_subs=0
        results2= sorted(ret, key=lambda x: (x['is_preferred'], x['lang_index'], x['sync'], x['rating']), reverse=True)
        if results2:
         for it in results2:
            ##logging.warning(it["filename"])
            number_of_subs=number_of_subs+1
            listitem = ListItem(label=it["language_name"],
                                        label2='[COLOR blue] [SC]' +it["filename"]+'[/COLOR]',
                                        iconImage=it["rating"],
                                        thumbnailImage=it["language_flag"]
                                        )
            if it["sync"]:
                listitem.setProperty("sync", "true")
            else:
                listitem.setProperty("sync", "false")

            if it.get("hearing_imp", False):
                listitem.setProperty("hearing_imp", "true")
            else:
                listitem.setProperty("hearing_imp", "false")
            ##logging.warning(it["link"])
            url = "plugin://%s/?action=download&link=%s&id=%s&filename=%s&language=%s" % (
                __scriptid__, it["link"], it["id"], it["filename"], it["language_flag"])
            if it["id"] not in id_collection:
              id_collection.append(it["id"])
              addDirectoryItem(handle=int(sys.argv[1]), url=url, listitem=listitem, isFolder=False)
        return number_of_subs
		
		
##########################################Subscene###############################
def clean_title(item):
    title = os.path.splitext(os.path.basename(item["title"]))
    tvshow = os.path.splitext(os.path.basename(item["tvshow"]))

    if len(title) > 1:
        if re.match(r'^\.[a-z]{2,4}$', title[1], re.IGNORECASE):
            item["title"] = title[0]
        else:
            item["title"] = ''.join(title)
    else:
        item["title"] = title[0]

    if len(tvshow) > 1:
        if re.match(r'^\.[a-z]{2,4}$', tvshow[1], re.IGNORECASE):
            item["tvshow"] = tvshow[0]
        else:
            item["tvshow"] = ''.join(tvshow)
    else:
        item["tvshow"] = tvshow[0]

	
    item["title"] = unicode(item["title"], "utf-8")
    item["tvshow"] = unicode(item["tvshow"], "utf-8")
    # Removes country identifier at the end
    item["title"] = re.sub(r'\([^\)]+\)\W*$', '', item["title"]).strip()
    item["tvshow"] = re.sub(r'\([^\)]+\)\W*$', '', item["tvshow"]).strip()


def parse_rls_title(item):
    title = regexHelper.sub(' ', item["title"])
    tvshow = regexHelper.sub(' ', item["tvshow"])

    groups = re.findall(r"(.*?) (\d{4})? ?(?:s|season|)(\d{1,2})(?:e|episode|x|\n)(\d{1,2})", title, re.I)

    if len(groups) == 0:
        groups = re.findall(r"(.*?) (\d{4})? ?(?:s|season|)(\d{1,2})(?:e|episode|x|\n)(\d{1,2})", tvshow, re.I)

    if len(groups) > 0 and len(groups[0]) >= 3:
        title, year, season, episode = groups[0]
        item["year"] = str(int(year)) if len(year) == 4 else year

        item["tvshow"] = regexHelper.sub(' ', title).strip()
        item["season"] = str(int(season))
        item["episode"] = str(int(episode))
        log("TV Parsed Item: %s" % (item,))


def normalizeString(str):
    return unicodedata.normalize(
        'NFKD', unicode(unicode(str, 'utf-8'))
    ).encode('utf-8', 'ignore')
def MyLog(msg):
	log((u"##**## [%s] %s" % ("Wizdom Subs", msg,)).encode('utf-8'), level=xbmc.LOGDEBUG)

if not exists(MyTmp):
	mkdirs(MyTmp)

action=None

if len(sys.argv) >= 2:   
	params = getParams(sys.argv[2])
	action = getParam("action", params)

MyLog("Version:%s"%MyVersion)
MyLog("Action:%s"%action)
try:
  language=params["language"]
except:
  language=''
try:
  key=params["link"]
except:
  key=''
try:
  filename=params["filename"]
except:
  filename=''
try:
  source=params["source"]
except:
  source=''
if action=='search':
	item = {}
	
	MyLog("isPlaying:%s"%Player().isPlaying())
	if Player().isPlaying():
		
		item['year'] = getInfoLabel("VideoPlayer.Year")  # Year

		item['season'] = str(getInfoLabel("VideoPlayer.Season"))  # Season
		if item['season']=='' or item['season']<1:
			item['season'] = 0
		item['episode'] = str(getInfoLabel("VideoPlayer.Episode"))  # Episode

		if item['episode']=='' or item['episode']<1:
			item['episode'] = 0
		item['tvshow'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.TVshowtitle"))  # Show
		if item['episode']==0:
			item['title'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.OriginalTitle"))  # no original title, get just Title
		else:	
			item['title'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.TVshowtitle"))  # Show
		if item['title'] == "":
			item['title'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.OriginalTitle"))  # try to get original title
		item['file_original_path'] = unquote(unicode(Player().getPlayingFile(), 'utf-8'))  # Full path of a playing file
		item['file_original_path'] = item['file_original_path'].split("?")
		item['file_original_path'] = path.basename(item['file_original_path'][0])[:-4]
		item['preferredlanguage'] = unicode(urllib.unquote(params.get('preferredlanguage', '')), 'utf-8')
		item['preferredlanguage'] = xbmc.convertLanguage(item['preferredlanguage'], xbmc.ISO_639_2)
		item['rar'] = True
	else:	# Take item params from window when kodi is not playing
		labelIMDB = getInfoLabel("ListItem.IMDBNumber")
		item['year'] = getInfoLabel("ListItem.Year")
		item['season'] = getInfoLabel("ListItem.Season")
		item['episode'] = getInfoLabel("ListItem.Episode")
		item['file_original_path'] = ""
		item['temp'] = False
		item['rar'] = False


		if item['season']=='' or item['season']<1:
			item['season'] = 0


		if item['episode']=='' or item['episode']<1:
			item['episode'] = 0
		if item['season'] == 0 or item['episode'] == 0:
		  item['tvshow'] =''
		else:
		  item['tvshow'] =take_title_from_focused_item()
		item['title'] = take_title_from_focused_item()

		item['3let_language'] = []
		item['preferredlanguage'] = unicode(urllib.unquote(params.get('preferredlanguage', '')), 'utf-8')
		item['preferredlanguage'] = xbmc.convertLanguage(item['preferredlanguage'], xbmc.ISO_639_2)
		
		labelType = getInfoLabel("ListItem.DBTYPE")  #movie/tvshow/season/episode	
		isItMovie = labelType == 'movie' or getCondVisibility("Container.Content(movies)")
		isItEpisode = labelType == 'episode' or getCondVisibility("Container.Content(episodes)")

		if isItMovie:
			item['title'] = getInfoLabel("ListItem.OriginalTitle")
		elif isItEpisode:
			item['title'] = getInfoLabel("ListItem.TVShowTitle")							
		else:
			item['title'] = "SearchFor..." # In order to show "No Subtitles Found" result.
	if item['title'] == "":
	  log("VideoPlayer.OriginalTitle not found")
	  item['title'] = normalizeString(xbmc.getInfoLabel("VideoPlayer.Title"))  # no original title, get just Title
	clean_title(item)
	parse_rls_title(item)
	dp = xbmcgui.DialogProgress()
	dp.create('מחפש כתוביות','Searching...')
	dp.update(0, 'Searching Subscenter')
	
	try:
	  if MyAddon.getSetting("subscenter")== 'true':
	    number_of_subs=subcenter_search(item)
	except:
	  dp.update(int((25)/100.0 * 100), '[COLOR red] Subcenter Failed [/COLOR]')
	  xbmc.sleep(1000)
	dp.update(int((25)/100.0 * 100), 'Searching Subscene ')
	try:
	  if MyAddon.getSetting("subscene")== 'true':
	    search_subscene(item)
	except:
	  dp.update(int((25)/100.0 * 100), '[COLOR red] Subscene Failed [/COLOR]')
	  xbmc.sleep(1000)
	dp.update(int((50)/100.0 * 100), 'Searching Wizdom')
	MyLog("item:%s"%item)
	imdb_id = 0
	if MyAddon.getSetting("wizrad")== 'true':
	 try:
		if Player().isPlaying():	# Enable using subtitles search dialog when kodi is not playing
			playerid_query = '{"jsonrpc": "2.0", "method": "Player.GetActivePlayers", "id": 1}'
			playerid = loads(executeJSONRPC(playerid_query))['result'][0]['playerid']
			imdb_id_query = '{"jsonrpc": "2.0", "method": "Player.GetItem", "params": {"playerid": ' + str(playerid) + ', "properties": ["imdbnumber"]}, "id": 1}'
			imdb_id = loads(executeJSONRPC (imdb_id_query))['result']['item']['imdbnumber']
			MyLog("imdb JSONPC:%s"%imdb_id)
		else:
			if labelIMDB:
				imdb_id = labelIMDB
			else:
				if isItMovie:
					imdb_id = "ThisIsMovie" #Search the movie by item['title'] for imdb_id 
				elif isItEpisode:
					imdb_id = "ThisIsEpisode" #Search by item['title'] for tvdb_id 
				else:
					imdb_id = "tt0"	# In order to show "No Subtitles Found" result => Doesn't recognize movie/episode
	 except:	pass
	
	 if imdb_id[:2]=="tt":	#Simple IMDB_ID
		GetJson(imdb_id,item['season'],item['episode'],item['file_original_path'])

	 else:
		# Search TV Show by Title
		if item['season'] or item['episode']:
			try:
				imdb_id = urlopen("http://api.wizdom.xyz/search.tv.php?name="+quote(item['title'])).read()
				MyLog("Search TV IMDB:%s [%s]"%(imdb_id,item['title']))
				if imdb_id<>'' and imdb_id<>0:
					GetJson(str(imdb_id),item['season'],item['episode'],item['file_original_path'])
			except:	pass
		# Search Movie by Title+Year
		else:
			try:
				imdb_id = SearchMovie(query=item['title'],year=item['year'])
				MyLog("Search IMDB:%s"%imdb_id)
				if not imdb_id[:2]=="tt":
					imdb_id = SearchMovie(query=item['title'],year=(int(item['year'])-1))
					MyLog("Search IMDB(2):%s"%imdb_id)
				if imdb_id[:2]=="tt":
					GetJson(imdb_id,0,0,item['file_original_path'])
			except:	pass
	 if not imdb_id:
		ManualSearch(item['title'])
	dp.update(int((75)/100.0 * 100), 'Searching Opensubtitle')
	try:
	  if MyAddon.getSetting("opensubtitle")== 'true':
	   Search_opensubtitle(item,imdb_id)
	except:
	  dp.update(int((25)/100.0 * 100), '[COLOR red] Opensubtitle Failed [/COLOR]')
	  xbmc.sleep(1000)
	dp.close()
	# Search Local File
	

	endOfDirectory(int(sys.argv[1]))
	if MyAddon.getSetting("Debug") == "true":
		if imdb_id[:2]=="tt":
			Dialog().ok("Debug "+MyVersion,str(item),"imdb: "+str(imdb_id))
		else:
			Dialog().ok("Debug "+MyVersion,str(item),"NO IDS")

elif action == 'manualsearch':
	searchstring = getParam("searchstring", params)
	ManualSearch(searchstring)
	endOfDirectory(int(sys.argv[1]))

elif action == 'download':
	id = getParam("id", params)
	MyLog("Download ID:%s"%id)
	if source=='subscence':
	  
	  if 'episode' in params:
	    subs = download_subscene(params["link"], params["episode"])
	  else:
	    subs = download_subscene(params["link"])
	elif source=='opensubtitle':
	    subs = Download_opensubtitle(params["ID"], params["link"],params["format"])
	else:
	  subs = download(id,language,key,filename)
	
	for sub in subs:
		listitem = ListItem(label=sub)
		addDirectoryItem(handle=int(sys.argv[1]), url=sub, listitem=listitem,isFolder=False)
	endOfDirectory(int(sys.argv[1]))
elif action=='clean':
	try:
		rmtree(MyTmp)
		store.delete("%")
		notify(32004)
	except: pass
	executebuiltin((u'Notification(%s,%s)' % (MyName, MyLang(32004))).encode('utf-8'))
elif action=='login':
	login(True)
